org.eclipse.viatra.integration.uml.derivedfeatures

## Class RelationshipRelatedElementMatcher

- java.lang.Object
- - org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper
  - - org.eclipse.viatra.query.runtime.api.impl.BaseMatcher<RelationshipRelatedElementMatch>
    - - org.eclipse.viatra.integration.uml.derivedfeatures.RelationshipRelatedElementMatcher

- All Implemented Interfaces:
    ViatraQueryMatcher<RelationshipRelatedElementMatch>

      public class RelationshipRelatedElementMatcher
      extends BaseMatcher<RelationshipRelatedElementMatch>

  Generated pattern matcher API of the org.eclipse.viatra.integration.uml.derivedfeatures.relationshipRelatedElement pattern, providing pattern-specific query methods.

  Use the pattern matcher on a given model via `on(ViatraQueryEngine)`, e.g. in conjunction with `ViatraQueryEngine#on(Notifier)`.

  Matches of the pattern will be represented as `RelationshipRelatedElementMatch`.

  Original source: ``

        @Surrogate(feature = "relatedElement")
        @QueryExplorer(checked = false)
       pattern relationshipRelatedElement(source: Relationship, target: Element)
       { find associationEndType(source, target); } or
       { find directedRelationshipSource(source, target); } or
       { find directedRelationshipTarget(source, target); }

  See Also:
    `RelationshipRelatedElementMatch`, `RelationshipRelatedElementProcessor`, `RelationshipRelatedElementQuerySpecification`

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `engine, querySpecification`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper

      `backend`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected RelationshipRelatedElementMatch` | `arrayToMatch(java.lang.Object[] match)` Converts the array representation of a pattern match to an immutable Match object.
    `protected RelationshipRelatedElementMatch` | `arrayToMatchMutable(java.lang.Object[] match)` Converts the array representation of a pattern match to a mutable Match object.
    `int` | `countMatches(org.eclipse.uml2.uml.Relationship pSource, org.eclipse.uml2.uml.Element pTarget)` Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
    `static RelationshipRelatedElementMatcher` | `create()`
    `void` | `forEachMatch(org.eclipse.uml2.uml.Relationship pSource, org.eclipse.uml2.uml.Element pTarget, IMatchProcessor<? super RelationshipRelatedElementMatch> processor)` Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `forOneArbitraryMatch(org.eclipse.uml2.uml.Relationship pSource, org.eclipse.uml2.uml.Element pTarget, IMatchProcessor<? super RelationshipRelatedElementMatch> processor)` Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `java.util.Collection<RelationshipRelatedElementMatch>` | `getAllMatches(org.eclipse.uml2.uml.Relationship pSource, org.eclipse.uml2.uml.Element pTarget)` Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
    `java.util.Set<org.eclipse.uml2.uml.Relationship>` | `getAllValuesOfsource()` Retrieve the set of values that occur in matches for source.
    `java.util.Set<org.eclipse.uml2.uml.Relationship>` | `getAllValuesOfsource(org.eclipse.uml2.uml.Element pTarget)` Retrieve the set of values that occur in matches for source.
    `java.util.Set<org.eclipse.uml2.uml.Relationship>` | `getAllValuesOfsource(RelationshipRelatedElementMatch partialMatch)` Retrieve the set of values that occur in matches for source.
    `java.util.Set<org.eclipse.uml2.uml.Element>` | `getAllValuesOftarget()` Retrieve the set of values that occur in matches for target.
    `java.util.Set<org.eclipse.uml2.uml.Element>` | `getAllValuesOftarget(org.eclipse.uml2.uml.Relationship pSource)` Retrieve the set of values that occur in matches for target.
    `java.util.Set<org.eclipse.uml2.uml.Element>` | `getAllValuesOftarget(RelationshipRelatedElementMatch partialMatch)` Retrieve the set of values that occur in matches for target.
    `RelationshipRelatedElementMatch` | `getOneArbitraryMatch(org.eclipse.uml2.uml.Relationship pSource, org.eclipse.uml2.uml.Element pTarget)` Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `hasMatch(org.eclipse.uml2.uml.Relationship pSource, org.eclipse.uml2.uml.Element pTarget)` Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
    `RelationshipRelatedElementMatch` | `newMatch(org.eclipse.uml2.uml.Relationship pSource, org.eclipse.uml2.uml.Element pTarget)` Returns a new (partial) match.
    `static RelationshipRelatedElementMatcher` | `on(ViatraQueryEngine engine)` Initializes the pattern matcher within an existing VIATRA Query engine.
    `static IQuerySpecification<RelationshipRelatedElementMatcher>` | `querySpecification()`
    `protected java.util.Set<org.eclipse.uml2.uml.Relationship>` | `rawAccumulateAllValuesOfsource(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for source.
    `protected java.util.Set<org.eclipse.uml2.uml.Element>` | `rawAccumulateAllValuesOftarget(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for target.
    `protected RelationshipRelatedElementMatch` | `tupleToMatch(Tuple t)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `countMatches, countMatches, emptyArray, forEachMatch, forEachMatch, forOneArbitraryMatch, forOneArbitraryMatch, getAllMatches, getAllMatches, getAllValues, getAllValues, getCapabilities, getEngine, getOneArbitraryMatch, getOneArbitraryMatch, getParameterNames, getPatternName, getPositionOfParameter, getSpecification, hasMatch, matchToArray, newEmptyMatch, newMatch, rawAccumulateAllValues, rawCountMatches, rawForEachMatch, rawForOneArbitraryMatch, rawGetAllMatches, rawGetAllValues, rawGetOneArbitraryMatch, rawHasMatch, setBackend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### on

          public static RelationshipRelatedElementMatcher on(ViatraQueryEngine engine)
                                                      throws ViatraQueryException

      Initializes the pattern matcher within an existing VIATRA Query engine. If the pattern matcher is already constructed in the engine, only a light-weight reference is returned. The match set will be incrementally refreshed upon updates.
      Parameters:
        `engine` - the existing VIATRA Query engine in which this matcher will be created.
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation

    - #### create

          public static RelationshipRelatedElementMatcher create()
                                                          throws ViatraQueryException

      Returns:
        an initialized matcher
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation
      No Reference:
        This method is for internal matcher initialization by the framework, do not call it manually.

    - #### getAllMatches

          public java.util.Collection<RelationshipRelatedElementMatch> getAllMatches(org.eclipse.uml2.uml.Relationship pSource,
                                                                                     org.eclipse.uml2.uml.Element pTarget)

      Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        matches represented as a RelationshipRelatedElementMatch object.

    - #### getOneArbitraryMatch

          public RelationshipRelatedElementMatch getOneArbitraryMatch(org.eclipse.uml2.uml.Relationship pSource,
                                                                      org.eclipse.uml2.uml.Element pTarget)

      Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        a match represented as a RelationshipRelatedElementMatch object, or null if no match is found.

    - #### hasMatch

          public boolean hasMatch(org.eclipse.uml2.uml.Relationship pSource,
                                  org.eclipse.uml2.uml.Element pTarget)

      Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        true if the input is a valid (partial) match of the pattern.

    - #### countMatches

          public int countMatches(org.eclipse.uml2.uml.Relationship pSource,
                                  org.eclipse.uml2.uml.Element pTarget)

      Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        the number of pattern matches found.

    - #### forEachMatch

          public void forEachMatch(org.eclipse.uml2.uml.Relationship pSource,
                                   org.eclipse.uml2.uml.Element pTarget,
                                   IMatchProcessor<? super RelationshipRelatedElementMatch> processor)

      Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
        `processor` - the action that will process each pattern match.

    - #### forOneArbitraryMatch

          public boolean forOneArbitraryMatch(org.eclipse.uml2.uml.Relationship pSource,
                                              org.eclipse.uml2.uml.Element pTarget,
                                              IMatchProcessor<? super RelationshipRelatedElementMatch> processor)

      Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
        `processor` - the action that will process the selected match.
      Returns:
        true if the pattern has at least one match with the given parameter values, false if the processor was not invoked

    - #### newMatch

          public RelationshipRelatedElementMatch newMatch(org.eclipse.uml2.uml.Relationship pSource,
                                                          org.eclipse.uml2.uml.Element pTarget)

      Returns a new (partial) match. This can be used e.g. to call the matcher with a partial match.

      The returned match will be immutable. Use `BaseMatcher.newEmptyMatch()` to obtain a mutable match object.

      Parameters:
        `pSource` - the fixed value of pattern parameter source, or null if not bound.
        `pTarget` - the fixed value of pattern parameter target, or null if not bound.
      Returns:
        the (partial) match object.

    - #### rawAccumulateAllValuesOfsource

          protected java.util.Set<org.eclipse.uml2.uml.Relationship> rawAccumulateAllValuesOfsource(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for source.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfsource

          public java.util.Set<org.eclipse.uml2.uml.Relationship> getAllValuesOfsource()

      Retrieve the set of values that occur in matches for source.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfsource

          public java.util.Set<org.eclipse.uml2.uml.Relationship> getAllValuesOfsource(RelationshipRelatedElementMatch partialMatch)

      Retrieve the set of values that occur in matches for source.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfsource

          public java.util.Set<org.eclipse.uml2.uml.Relationship> getAllValuesOfsource(org.eclipse.uml2.uml.Element pTarget)

      Retrieve the set of values that occur in matches for source.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOftarget

          protected java.util.Set<org.eclipse.uml2.uml.Element> rawAccumulateAllValuesOftarget(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for target.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftarget

          public java.util.Set<org.eclipse.uml2.uml.Element> getAllValuesOftarget()

      Retrieve the set of values that occur in matches for target.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftarget

          public java.util.Set<org.eclipse.uml2.uml.Element> getAllValuesOftarget(RelationshipRelatedElementMatch partialMatch)

      Retrieve the set of values that occur in matches for target.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftarget

          public java.util.Set<org.eclipse.uml2.uml.Element> getAllValuesOftarget(org.eclipse.uml2.uml.Relationship pSource)

      Retrieve the set of values that occur in matches for target.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### tupleToMatch

          protected RelationshipRelatedElementMatch tupleToMatch(Tuple t)

      Specified by:
        `tupleToMatch` in class `BaseMatcher<RelationshipRelatedElementMatch>`

    - #### arrayToMatch

          protected RelationshipRelatedElementMatch arrayToMatch(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to an immutable Match object.
      Specified by:
        `arrayToMatch` in class `BaseMatcher<RelationshipRelatedElementMatch>`

    - #### arrayToMatchMutable

          protected RelationshipRelatedElementMatch arrayToMatchMutable(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to a mutable Match object.
      Specified by:
        `arrayToMatchMutable` in class `BaseMatcher<RelationshipRelatedElementMatch>`

    - #### querySpecification

          public static IQuerySpecification<RelationshipRelatedElementMatcher> querySpecification()
                                                                                           throws ViatraQueryException

      Returns:
        the singleton instance of the query specification of this pattern
      Throws:
        `ViatraQueryException` - if the pattern definition could not be loaded